﻿using System;
using System.Threading;
using System.Windows.Forms;
using CSDesktopSample;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace LayerDrawingIndicator
{
    public partial class Form1 : Form
    {
        private WorldMapKitRenderLayer worldMapKitRenderLayer;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string worldMapKitDataFolder = @"C:\WorldMapKitData";
            worldMapKitRenderLayer = new WorldMapKitRenderLayer(worldMapKitDataFolder);

            LayerOverlay worldMapKitRenderLayerOverlay = new LayerOverlay();
            worldMapKitRenderLayerOverlay.Layers.Add(worldMapKitRenderLayer);
            winformsMap1.Overlays.Add(worldMapKitRenderLayerOverlay);
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.ExtentOverlay.ZoomPercentage = 50;
            winformsMap1.CurrentExtent = WorldMapKitRenderLayer.DefaultExtent;

            worldMapKitRenderLayer.WorldMapKitLayerDrawn += new EventHandler<WorldMapKitLayerDrawnEventArgs>(worldMapKitRenderLayer_WorldMapKitLayerDrawn);
            winformsMap1.Refresh();
        }

        void worldMapKitRenderLayer_WorldMapKitLayerDrawn(object sender, WorldMapKitLayerDrawnEventArgs e)
        {
            this.progressBar1.Maximum = e.LayerCount;
            this.Invoke(new ThreadStart(() =>
            {
                this.progressBar1.Value = e.LayerDrawn;
            }));

        }
    }
}
